using UnityEngine;using System.Collections.Generic;using MeshVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using System.Linq;using Battlehub.RTCommon;using UnityEngine.UI;namespace PluginIdea.GizmosSystem{public class GizmosSystem : MVRScript, IGL{public const string InputModule = "InputModule";public const string HudHanderModule = "HudHanderModule";public const string MeshDrawModule = "MeshDrawModule";public const string LightDrawModule = "LightDrawModule";public const string CameraDrawModule = "CameraDrawModule";public const string PersonDrawModule = "PersonDrawModule";public const string AudioSourceDrawModule = "AudioSourceDrawModule";public const string FreeControllerModule = "FreeControllerModule";public const string ColliderDrawModule = "ColliderDrawModule";private Request request;private Dictionary<string, GZModuleBase> uid2Modules = new Dictionary<string, GZModuleBase>();private Dictionary<string, Mesh> dic_Meshs = new Dictionary<string, Mesh>();private List<string> meshnames = new List<string>{"arm", "chest", "enbow", "footL", "footR", "handL", "handR", "head", "knee", "pelvis"};private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();private Dictionary<string, Camera> dic_name2Camera = new Dictionary<string, Camera>();private Atom currentSelectedAtom;private CameraHook cameraHook;public Atom CurrentDrawAtom{get{return this.currentSelectedAtom;}}public Dictionary<string, Shader> Dic_BundleShaders{get{return this.dic_BundleShaders;}}public Dictionary<string, Mesh> Dic_Meshes{get{return this.dic_Meshs;}}public Transform CenterCameraTrans{get{if (Utils.IsInVR()){if (SuperController.singleton.isOpenVR){return SuperController.singleton.ViveCenterCamera.transform;}return SuperController.singleton.OVRCenterCamera.transform;}else{return SuperController.singleton.MonitorCenterCamera.transform;}}}public override void Init(){Utils.OnInitUI(CreateUIElement);Utils.SetupInfoText(this, Location.GetStr(Location.PluginInfo), 400, true);ResourceInit();EventInit();}private void ResourceInit(){string assetsBundlePath = Utils.GetPluginPath(this) + string.Format("/resources/gzsystem{0}.assetbundle", Utils.version);request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request request){Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){if (!dic_BundleShaders.ContainsKey(shaders[i].name)){dic_BundleShaders.Add(shaders[i].name, shaders[i]);}}meshnames.ForEach(n =>{GameObject gb = request.assetBundle.LoadAsset<GameObject>(n);Mesh mesh = gb.GetComponentInChildren<MeshFilter>().sharedMesh;dic_Meshs.Add(n, mesh);});foreach (var module in uid2Modules.Values.ToList()){module.OnReApply();}}private void EventInit(){RegisterModule(MeshDrawModule, new MeshDrawMoudle(this));RegisterModule(LightDrawModule, new LightDrawModule(this));RegisterModule(AudioSourceDrawModule, new AudioSourceDrawModule(this));RegisterModule(FreeControllerModule, new FreeControllerModule(this));RegisterModule(CameraDrawModule, new CameraDrawModule(this));}private void Start(){if (Utils.IsInVR()){cameraHook = Utils.GetSafeComponent<CameraHook>(CenterCameraTrans.gameObject);cameraHook.onPostRenderCallback += OnPostRender;}else{if (GLRenderer.Instance == null){new GameObject{name = "GLRenderer"}.AddComponent<GLRenderer>();}GLRenderer.Instance.Add(this);}}private void Update(){currentSelectedAtom = SuperController.singleton.GetSelectedAtom();foreach (var module in uid2Modules.Values.ToList()){module.OnUpdate();}}private void RegisterModule(string key, GZModuleBase module){if (!uid2Modules.ContainsKey(key)){uid2Modules.Add(key, module);module.Init();}}private void UnRegisterModule(string key){if (uid2Modules.ContainsKey(key)){uid2Modules[key].UnInit();uid2Modules.Remove(key);}}private void OnDestroy(){if (uid2Modules.Count > 0){foreach (var key in uid2Modules.Keys.ToList()){UnRegisterModule(key);}uid2Modules.Clear();}if (Utils.IsInVR()){Destroy(cameraHook);}else{GLRenderer.Instance.Remove(this);}Utils.OnDestroyUI();}private void OnPostRender(){foreach (var module in uid2Modules.Values.ToList()){module.OnPostRender();}}public void Draw(int cullingMask){OnPostRender();}}}